 <?php

if (!defined('_PS_VERSION_'))
    exit;
class DMTPayamak extends Module
{
    private $prefix;
    private $WebserviceName;
    private $webservice;
    public function __construct()
    {
        $this->name          = 'dmtpayamak';
        $this->tab           = 'others';
        $this->version       = '1.0';
        $this->author        = 'Tech-Ghasedak';
        $this->need_instance = 0;
        
        parent::__construct();
        
        $this->displayName      = $this->l('Ghasedak');
        $this->description      = $this->l('PrestaShop1.5');
        $this->confirmUninstall = $this->l('Are you sure you want to uninstall?');
        $this->prefix           = 'PS15';
        
        if ($this->id)
            $this->WebserviceName = Configuration::get($this->prefix . 'SELECTWEBSERVICE');
            
        if (!$this->loadWebService($this->WebserviceName))
         {
            $webservices=$this->getNameOfFiles(_PS_MODULE_DIR_.'dmtpayamak/webservices/');
            if(count($webservices)==0)
            $this->webservice=false;
            else
            {
                $webservicename=explode('.',end($webservices));
                Configuration::updateValue($this->prefix . 'SELECTWEBSERVICE',$webservicename[0]);
                $this->webservice=$webservicename[0];
            }
         } 
        else {
            $this->webservice = new $this->WebserviceName();
            $this->webservice->setProperty($this->prefix, Configuration::get($this->prefix . 'USERNAME'), Configuration::get($this->prefix . 'PASSWORD'));
        }
        
    }
    
    public function install()
    {
        if (!$this->installConfig())
            return false;
        
        if (!$this->installDatabase())
            return false;
        
        if (!parent::install() OR !$this->registerHook('actionValidateOrder') OR !$this->registerHook('actionOrderStatusPostUpdate') OR !$this->registerHook('updateQuantity') OR !$this->registerHook('actionCustomerAccountAdd'))
            return false;
        
    }
    
    public function uninstall()
    {
        if (!$this->uninstallConfig())
            return false;
        
        if (!$this->unistallDatabase())
            return false;
        
        if (!parent::uninstall())
            return false;
    }
    
    protected function installConfig()
    {
        if (!Configuration::updateValue($this->prefix . 'USERNAME', '0') 
        OR !Configuration::updateValue($this->prefix . 'PASSWORD', '0') 
        OR !Configuration::updateValue($this->prefix . 'ADMINPHONE', '0') 
        OR !Configuration::updateValue($this->prefix . 'NEWORDERA', '1') 
        OR !Configuration::updateValue($this->prefix . 'NEWORDERC', '0') 
        OR !Configuration::updateValue($this->prefix . 'UPDATEORDERC', '1') 
        OR !Configuration::updateValue($this->prefix . 'NEWCUSTOMERA', '1') 
        OR !Configuration::updateValue($this->prefix . 'NEWCUSTOMERC', '0') 
        OR !Configuration::updateValue($this->prefix . 'NEWORDERFC', '0') 
        OR !Configuration::updateValue($this->prefix . 'NEWORDERFA', '0') 
        OR !Configuration::updateValue($this->prefix . 'SENDERNUMBER', 0) 
        OR !Configuration::updateValue($this->prefix . 'SELECTWEBSERVICE', 'Ghasedak') OR
           !Configuration::updateValue($this->prefix . 'FLASH',0))
            return false;
        
        return true;
    }
    
    protected function uninstallConfig()
    {
        if (!Configuration::deleteByName($this->prefix . 'USERNAME')
         OR !Configuration::deleteByName($this->prefix . 'PASSWORD') 
         OR !Configuration::deleteByName($this->prefix . 'ADMINPHONE')
          OR !Configuration::deleteByName($this->prefix . 'NEWORDERA') 
          OR !Configuration::deleteByName($this->prefix . 'NEWORDERC') 
          OR !Configuration::deleteByName($this->prefix . 'UPDATEORDERC') 
          OR !Configuration::deleteByName($this->prefix . 'NEWCUSTOMERA') 
          OR !Configuration::deleteByName($this->prefix . 'NEWCUSTOMERC') 
          OR !Configuration::deleteByName($this->prefix . 'NEWORDERFC') OR 
          !Configuration::deleteByName($this->prefix . 'NEWORDERFA') OR 
          !Configuration::deleteByName($this->prefix . 'SENDERNUMBER') OR 
          !Configuration::deleteByName($this->prefix . 'SELECTWEBSERVICE') OR
          !Configuration::deleteByName($this->prefix . 'FLASH'))
            return false;
        
        return true;
    }
    
    protected function installDatabase()
    {
        $sql = 'CREATE TABLE IF NOT EXISTS `' . _DB_PREFIX_ . $this->name . '`( 
                `id_' . $this->name . '` INT(11) NOT NULL AUTO_INCREMENT PRIMARY KEY, 
                `status` VARCHAR(256) NOT NULL , 
                 `description` TEXT NOT NULL
                 )ENGINE=' . _MYSQL_ENGINE_ . ' DEFAULT CHARSET=utf8';
        return Db::getInstance()->execute($sql);
    }
    
    protected function unistallDatabase()
    {
        $sql = 'DROP TABLE IF EXISTS `' . _DB_PREFIX_ . $this->name . '`';
        return Db::getInstance()->execute($sql);
    }
    
    public function getContent()
    {
        $accountInfo = array(
            'USERNAME',
            'PASSWORD',
            'ADMINPHONE',
            'SENDERNUMBER'
        );
        $options     = array(
            'NEWORDERA',
            'NEWORDERC',
            'UPDATEORDERC',
            'NEWCUSTOMERA',
            'NEWCUSTOMERC',
            'NEWORDERFC',
            'NEWORDERFA',
            'FLASH'
        );
        $output      = '<h2>' . $this->name . '</h2>';
        //update account info
        if(!$this->webservice)
        {
           $output='<center >'. Tools::displayError($this->l('please Select Ghasedak webservice ')).'<a href="http://www.sms-ghasedak-ict.com" style="color:red">'.$this->l('here').'</a></center>';
           return $output;
        }
        else
        {
        if (Tools::isSubmit('updateInfo')) 
        { 
            
                foreach ($accountInfo as $key) {
                    if (!isset($_POST[$key]))
                        $_POST[$key] = 0;
                }
                
                foreach ($_POST as $key => $value) {
                    if (!Configuration::updateValue($this->prefix . $key, $value)) {
                        $errors[] = Tools::displayError($this->l('account informations is not updated'));
                        break;
                    }
                }
                if (isset($errors) && count($errors))
                    $output .= $this->displayError(implode('<br />', $errors));
                else
                    $output .= $this->displayConfirmation($this->l('informations updated'));
        }
        
        //update settings
        elseif (Tools::isSubmit('updateSettings')) {
            foreach ($options as $key) {
                if (!isset($_POST[$key]))
                    $_POST[$key] = 0;
            }
            
            foreach ($_POST as $key => $value) {
                if (!Configuration::updateValue($this->prefix . $key, $value)) {
                    $errors[] = Tools::displayError($this->l('Settings is not updated'));
                    break;
                }
            }
            if (isset($errors) && count($errors))
                $output .= $this->displayError(implode('<br />', $errors));
            else
                $output .= $this->displayConfirmation($this->l('Settings updated'));
        } elseif (Tools::isSubmit('SendSMS')) {
            $phones = Tools::getValue('reciver');
            if (strlen($phones) < 11)
                $errors[] = Tools::displayError($this->l('insert valid phone number'));
            else {
                $text = Tools::getValue('text');
                
               
                $result   = $this->webservice->sendOne($text, $phones, 'private');
                if ($result != 'sent')
                    $errors[] = Tools::displayError($result);
                
            }
            if (isset($errors) && count($errors))
                $output .= $this->displayError(implode('<br />', $errors));
            else
                $output .= $this->displayConfirmation($this->l('sent'));
        } elseif (Tools::isSubmit('SendCustomers')) {
            $text = Tools::getValue('textc');
            if (Tools::isEmpty($text))
                $errors[] = Tools::displayError($this->l('text is empty'));
            $phones = $this->getPhoneMobiles();
            
            
           
            $result   = $this->webservice->sendOne($text, $phones, 'sendToCustomers');
            if ($result != 'sent')
                $errors[] = Tools::displayError($result);
            if (isset($errors) && count($errors))
                $output .= $this->displayError(implode('<br />', $errors));
            else
                $output .= $this->displayConfirmation($this->l('sent to customers'));
        }
        elseif(Tools::isSubmit('updateWebservice'))
        {
            $webservicename=Tools::getValue('webserviceSelect');
            
            if($webservicename !='0' AND ($webservicename != Configuration::get($this->prefix . 'SELECTWEBSERVICE')))
            {
                foreach($accountInfo as $key)
                {
                    Configuration::updateValue($this->prefix .$key,'0');
                }
                configuration::updateValue($this->prefix . 'SELECTWEBSERVICE',$webservicename);
            }
            
            if(@$_FILES['file']['name'])
            {
                if(!$this->handleUpload())
                $errors[]=Tools::displayError($this->l('error in upload file'));
            }
             if (isset($errors) && count($errors))
                $output .= $this->displayError(implode('<br />', $errors));
            else
                $output .= $this->displayConfirmation($this->l('update webservice settings'));
        }
        return $output . $this->displayForm();
        
    }
    }
    
    protected function displayForm()
    {
        $phone_mobiles = $this->getPhoneMobiles(true);
        $return        = $this->webservice->getContentForm();
        $return .= '
                <fieldset>
                <legend><img src="' . $this->_path . 'views/img/settings.gif" alt="" title="" /> ' . $this->l('settings') . '</legend>
                <form name="config" action="' . $_SERVER['REQUEST_URI'] . '" method="post">
                <label>' . $this->l('Alerts on new order:') . '</label>
                <div class="margin-form"><span style="color:#000000; font-size:12px; margin-bottom:6px"><input type="checkbox" value="1" name="NEWORDERA" ' . (Configuration::get($this->prefix . 'NEWORDERA') == '1' ? 'checked' : '') . ' onclick="if(this.checked){document.config.alert_free_order.disabled=false;}else{document.config.alert_free_order.disabled=true;}"/>&nbsp;' . $this->l('admin') . '</span>
                <span style="color:#000000; font-size:12px; margin-bottom:6px"><input type="checkbox" value="1" name="NEWORDERC"  ' . (Configuration::get($this->prefix . 'NEWORDERC') == '1' ? 'checked="checked"' : '') . ' onclick="if(this.checked){document.config.alert_free_order.disabled=false;}else{document.config.alert_free_order.disabled=true;}"/>&nbsp;' . $this->l('customer') . '</span><div>' . $this->l('Send SMS if a new order is made') . '</div></div>
        
                <label>' . $this->l('Alerts on new free order:') . '</label>
                <div class="margin-form"><span style="color:#000000; font-size:12px; margin-bottom:6px"><input type="checkbox" value="1" name="NEWORDERFA" ' . (Configuration::get($this->prefix . 'NEWORDERFA') == '1' ? 'checked' : '') . ' onclick="if(this.checked){document.config.alert_free_order.disabled=false;}else{document.config.alert_free_order.disabled=true;}"/>&nbsp;' . $this->l('admin') . '</span>
                <span style="color:#000000; font-size:12px; margin-bottom:6px"><input type="checkbox" value="1" name="NEWORDERFC"  ' . (Configuration::get($this->prefix . 'NEWORDERFC') == '1' ? 'checked="checked"' : '') . ' onclick="if(this.checked){document.config.alert_free_order.disabled=false;}else{document.config.alert_free_order.disabled=true;}"/>&nbsp;' . $this->l('customer') . '</span><div>' . $this->l('Send SMS if a new order is free made') . '</div></div>';
        
        
        $return .= '<label>' . $this->l('Alerts on update order status:') . '</label>
                <div class="margin-form"><div style="color:#000000; font-size:12px; margin-bottom:6px"><input type="checkbox" value="1" name="UPDATEORDERC" ' . (Configuration::get($this->prefix . 'UPDATEORDERC') == '1' ? 'checked' : '') . ' onclick="if(this.checked){document.config.alert_update_free_order.disabled=false;}else{document.config.alert_update_free_order.disabled=true;}"/>&nbsp;' . $this->l('Yes') . '</div>' . $this->l('Send SMS to customer if an order status is changed') . '</div>
                <label>' . $this->l('Alerts on create new account:') . '</label>
                <div class="margin-form"><span style="color:#000000; font-size:12px; margin-bottom:6px"><input type="checkbox" value="1" name="NEWCUSTOMERA" ' . (Configuration::get($this->prefix . 'NEWCUSTOMERA') == '1' ? 'checked' : '') . ' onclick="if(this.checked){document.config.alert_free_order.disabled=false;}else{document.config.alert_free_order.disabled=true;}"/>&nbsp;' . $this->l('admin') . '</span><div>' . $this->l('Send SMS if a new customer  is add to site') . '</div></div>
                <br />
                <label>' . $this->l('Flash send:') . '</label>
                <div class="margin-form"><div style="color:#000000; font-size:12px; margin-bottom:6px"><input type="checkbox" value="1" name="FLASH" ' . (Configuration::get($this->prefix . 'FLASH') == '1' ? 'checked' : '') . ' onclick="if(this.checked){document.config.alert_update_free_order.disabled=false;}else{document.config.alert_update_free_order.disabled=true;}"/>&nbsp;' . $this->l('Yes') . '</div>' . $this->l('Send SMS with flash method ') . '</div>
                
                <br />
                <div class="margin-form"><input class="button" name="updateSettings" value="' . $this->l('Update settings') . '" type="submit" /></div>
            </form>
        </fieldset>
        <br />
        <fieldset>
        <legend><img src="' . $this->_path . 'views/img/settings.gif" alt="" title="" /> ' . $this->l('Send sms') . '</legend>
            <form name="config" action="' . $_SERVER['REQUEST_URI'] . '" method="post">
            <label>' . $this->l('sent to:') . '</label>
                <div class="margin-form"><textarea name="reciver" cols="10" rows="5" ></textarea><br />' . $this->l('ex:09123456789') . '<br />' . $this->l('for send sms more than on number please saperate numbers with ; ex:09123456789;09101234567') . '</div>
                <br />
                <label>' . $this->l('Text message:') . '</label>
                <div class="margin-form"><textarea  name="text"  ></textarea> </div>
                <br />
                <div class="margin-form"><input class="button" name="SendSMS" value="' . $this->l('Send sms') . '" type="submit" /></div>
            </form>
             </fieldset>
             <br />
             <fieldset>
        <legend><img src="' . $this->_path . 'views/img/settings.gif" alt="" title="" /> ' . $this->l('Send sms for customers') . '</legend>
            <form name="config" action="' . $_SERVER['REQUEST_URI'] . '" method="post">
               <div class="margin-form">  <label>' . $phone_mobiles . ' ' . $this->l('phone mobile(s) from customers is exist') . '</div><br />
                <label>' . $this->l('Text message') . '</label>
                <div class="margin-form"><textarea  name="textc"  ></textarea> </div>
                <br />
                <div class="margin-form"><input class="button" name="SendCustomers" value="' . $this->l('Send sms') . '" type="submit" /></div>
            </form>
             </fieldset>
             <br />';
             //select and upload webservice
             $return .=
             '<fieldset>
             <legend><img src="' . $this->_path . 'views/img/settings.gif" alt="" title="" /> ' . $this->l('webservices settings') . '</legend>
            <form name="config" action="' . $_SERVER['REQUEST_URI'] . '" method="post" enctype="multipart/form-data">
               <label>' . $this->l('choose webservice') . '</label>
               <div class="margin-form">'.$this->listWebservice().'</div>
               <label>' . $this->l('upload websrvice file') . '</label>
               <div class="margin-form"><input type="file"  name="file" /></div>
               <div class="margin-form"><input class="button" name="updateWebservice" value="' . $this->l('update webservices') . '" type="submit" /></div>
            </form>
             </fieldset>
             <br />';
             $return.=$this->webservice->getContentFooter();
        return $return;
    }
    
    public function hookActionCustomerAccountAdd($params)
    {
        if (Configuration::get($this->prefix . 'USERNAME') == '0' OR Configuration::get($this->prefix . 'PASSWORD') == '0' OR Configuration::get($this->prefix . 'NEWCUSTOMERA') == 0 AND Configuration::get($this->prefix . 'NEWCUSTOMERC') == 0)
            return true;
        
        if (Configuration::get($this->prefix . 'NEWCUSTOMERA') != 0 AND Configuration::get($this->prefix . 'ADMINPHONE') == 0)
            return true;
        
        
        
        if (is_object($params['newCustomer']))
            $newCustomer = get_object_vars($params['newCustomer']);
        
        $firstName = $newCustomer['firstname'];
        $lastName  = $newCustomer['lastname'];
        
        
        $vars = array(
            '{firstname}' => $firstName,
            '{lastname}' => $lastName
        );
        if (Configuration::get($this->prefix . 'NEWCUSTOMERA') != 0) {
            if (!$text = $this->getText($vars, 'newacount', 'admin'))
                die('not file ');
            $this->webservice->sendOne($text, Configuration::get($this->prefix . 'ADMINPHONE'), 'newAccount');
        }
        if (Configuration::get($this->prefix . 'NEWCUSTOMERC') != 0) {
            $id_address      = Address::getFirstCustomerAddressId($newCustomer['id']);
            $customerAddress = new AddressCore($id_address);
            $phone           = $customerAddress->phone_mobile;
            
            if (!$phone OR strlen($phone) < 10)
                return true;
            if (!$text = $this->getText($vars, 'newacount', 'customer'))
                die('not file ');
            
            $this->webservice->sendOne($text, $phone, 'neworder');
        }
        
        return true;
        
    }
    
    public function hookActionValidateOrder($params)
    {
        if (Configuration::get($this->prefix . 'USERNAME') == '0' OR Configuration::get($this->prefix . 'PASSWORD') == '0' OR (Configuration::get($this->prefix . 'NEWORDERA') == 0 AND Configuration::get($this->prefix . 'NEWORDERC') == 0))
            return true;
        
        if (Configuration::get($this->prefix . 'NEWCUSTOMERA') != 0 AND Configuration::get($this->prefix . 'ADMINPHONE') == 0)
            return true;
        
        
        
        
        
        $order    = $params['order'];
        $customer = $params['customer'];
        $currency = $params['currency'];
        $address  = new Address(intval($order->id_address_invoice));
        
        
        $vars = array(
            '{firstname}' => ($customer->firstname),
            '{lastname}' => ($customer->lastname),
            '{order_name}' => sprintf("%06d", $order->id),
            '{shop_name}' => Configuration::get('PS_SHOP_NAME'),
            '{payment}' => $order->payment,
            '{total_paid}' => $order->total_paid,
            '{currency}' => $currency->name
        );
        
        if (Configuration::get($this->prefix . 'NEWORDERA') != 0) {
            if ($order->total_paid == 0 AND Configuration::get($this->prefix . 'NEWORDERFA') == 0)
                return true;
            
            if (!$text = $this->getText($vars, 'neworder', 'admin'))
                die('not file ');
            
            $this->webservice->sendOne($text, Configuration::get($this->prefix . 'ADMINPHONE'), 'neworder');
        }
        
        if (Configuration::get($this->prefix . 'NEWORDERC') != 0) {
            if ($order->total_paid == 0 AND Configuration::get($this->prefix . 'NEWORDERFC') == 0)
                return true;
            
            $id_address      = Address::getFirstCustomerAddressId($customer->id);
            $customerAddress = new AddressCore($id_address);
            $phone           = $customerAddress->phone_mobile;
            
            if (!$phone OR strlen($phone) < 10)
                return true;
            if (!$text = $this->getText($vars, 'neworder', 'customer'))
                die('not file ');
            
            $this->webservice->sendOne($text, $phone, 'neworder');
        }
        return true;
    }
    
    public function hookActionOrderStatusPostUpdate($params)
    {
        
        if (Configuration::get($this->prefix . 'USERNAME') == '0' OR Configuration::get($this->prefix . 'PASSWORD') == '0' OR (Configuration::get($this->prefix . 'NEWCUSTOMERA') == 0 AND Configuration::get($this->prefix . 'NEWCUSTOMERC') == 0))
            return true;
        
        if (Configuration::get($this->prefix . 'UPDATEORDERC') == 0)
            return true;
        
        
       
        $order      = new Order((int) ($params['id_order']));
        $orderstate = $params['newOrderStatus'];
        
        $customer   = new Customer((int) $order->id_customer);
        $id_address = Address::getFirstCustomerAddressId($customer->id);
        $address    = new Address((int) ($id_address));
        if ($address->phone_mobile == null)
            return true;
        
        if (strtolower($orderstate->name) == strtolower('Awaiting cheque payment') OR strtolower($orderstate->name) == strtolower('Awaiting bank wire payment'))
            return true;
        $vars = array(
            '{firstname}' => ($customer->firstname),
            '{lastname}' => ($customer->lastname),
            '{order_name}' => sprintf("%06d", $order->id),
            '{shop_name}' => Configuration::get('PS_SHOP_NAME'),
            '{order_state}' => $orderstate->name
        );
        
        if (!$text = $this->getText($vars, 'updateorder', 'customer'))
            die('not file ');
        
        $this->webservice->sendOne($text, $address->phone_mobile, 'updateorder');
        
        return true;
    }
    
    /** load text message
     * @param array vars varible to set in tamplate
     * @param string folder exists template
     * @param string folder exists txtfile nam
     * @return text message
     */
    private function getText($vars, $folder, $txtfile)
    {
        $language = Language::getIsoById((int) (Configuration::get('PS_LANG_DEFAULT')));
        $file     = dirname(__FILE__) . '/views/smstemp/' . $language . '/' . $folder . '/' . $txtfile . '.txt';
        
        if (!file_exists($file))
            return false;
        
        $tpl      = file($file);
        $template = str_replace(array_keys($vars), array_values($vars), $tpl);
        return (implode("", $template));
        
    }
    
    /** save logs to database 
     * @param string status
     * @param string logs form webservice
     * @return boolean 
     */
    public function saveLogs($status, $description)
    {
        $fields = array(
            'status' => pSQL($status),
            'description' => pSQL($description)
        );
        return Db::getInstance()->insert($this->name, $fields);
    }
    
    /** get phone mobile from customers
     * @return strings of phonemobiles
     */
    protected function getPhoneMobiles($getTotal = false)
    {
        //get mobiles
        if (!$getTotal) {
            $sql = new DbQueryCore();
            $sql->select('phone_mobile');
            $sql->from('address');
            $query = $sql->build();
            
            $results = Db::getInstance(_PS_USE_SQL_SLAVE_)->executeS($query);
            if ($results and count($results) > 0)
                foreach ($results as $result) {
                    if (!Tools::isEmpty($result['phone_mobile']))
                        $mobiles .= $result['phone_mobile'] . ';';
                } else
                return false;
            
            return trim($mobiles, ';');
        } else {
            $sql = new DbQueryCore();
            $sql->select('count(*)');
            $sql->from('address');
            $sql->where('phone_mobile !=""');
            $query = $sql->build();
            return Db::getInstance(_PS_USE_SQL_SLAVE_)->getValue($sql);
        }
        
    }
    
    /** load webservice class
     * require selected webservice
     * @params string ClassName
     * @return boolean
     */
    protected function loadWebService($ClassName)
    {
        $pathWebService = dirname(__FILE__) . '/webservices/' . $ClassName . '.php';
        if (file_exists($pathWebService))
            require_once($pathWebService);
        
        
        else
            return false;
        
        return true;
    }
    
    /** get name of webservice is exsit 
     * @return array of names
     */
    protected function listWebservice()
    {
        $html='<select name="webserviceSelect">
                <option value="0">chooseOne</option>>';
        $sourceDir=_PS_MODULE_DIR_.'dmtpayamak/webservices/';
        $webservices=$this->getNameOfFiles($sourceDir);
        foreach ($webservices as $webservice)
        {
            $item=explode('.',$webservice);
           
            $html.='<option value="'.$item[0].'">'.$item[0].'</option>';
        }
        $html.='</select>';
        
        return $html;
    }
    
    /** get name of file in specail directory
     * @param get directory
     * @return directory
     */
    
    protected function getNameOfFiles($directory, $recursive=false)
    {
        
        $array_items = array();
        if ($handle = opendir($directory)) {
            while (false !== ($file = readdir($handle))) {
                if ($file != "." && $file != "..") {
                    if (is_dir($directory . "/" . $file)) {
                        if ($recursive) {
                            $array_items = array_merge($array_items, directoryToArray($directory . "/" . $file, $recursive));
                        }
                        // $file = $directory . "/" . $file;
                        $array_items[] = preg_replace("/\/\//si", "/", $file);
                    } else {
                        // $file = $directory . "/" . $file;
                        $array_items[] = preg_replace("/\/\//si", "/", $file);
                    }
                }
            }
            closedir($handle);
        }
        if(($key=array_search('index.php',$array_items)) !==false)
        unset($array_items[$key]);
        return $array_items;
    }
    
    /** upload file function
     */
     
     protected function handleUpload()
     {
        $sourceDir=_PS_MODULE_DIR_.'dmtpayamak/webservices/';
        $extension = explode(".", $_FILES["file"]["name"]);
        $prefix=end($extension);
        if ($prefix !='php')
        {
        return false;
        }
        if ($_FILES["file"]["error"] > 0)
        {
        return false;
        }
        else
        {
        move_uploaded_file($_FILES["file"]["tmp_name"],
        $sourceDir.$_FILES["file"]["name"]);
        Configuration::updateValue($this->prefix.'SELECTWEBSERVICE',$extension[0]);
        return true;
        }
  }
}